<?php

declare(strict_types=1);
namespace Drupal\translation_bliss\Drush\Commands\Extraction\Utility;

use Drupal\Core\File\FileSystemInterface;

/**
 * @internal
 */
trait DirectoryValidationTrait {

  /**
   * @param list<string> $dirs
   */
  private function validateDirs(array &$dirs, $createIfNeeded = FALSE): void {
    foreach ($dirs as &$dir) {
      $this->validateDir($dir, $createIfNeeded);
    }
  }

  private function validateDir(string &$dir, $createIfNeeded = FALSE): void {
    $dir = rtrim($dir, '/');
    if ($createIfNeeded && !is_dir($dir)) {
      $this->fileSystem->prepareDirectory($dir, FileSystemInterface::CREATE_DIRECTORY | FileSystemInterface::MODIFY_PERMISSIONS);
    }
    if (!is_dir($dir)) {
      $cwd = getcwd();
      throw new \UnexpectedValueException("Not a directory: '$dir', cwd='$cwd'");
    }
  }

}
